import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class actions extends PApplet {public void myActions() { // actions to be executed at each frame
    size(600, 600); 
    // prints text at top of the graphic window (see TAB UI), line 0
    if ((mousePressed)&&(!keyPressed)) dragPoint();    // while mouse pressed moves the selected point by mouse displacement (in TAB polygon)
    fill(black);              // set fill color to black (for writing text in the windows)
    strokeWeight(3);          // set stroke width to 3
    stroke(blue);             // set current color to blue
    pt A=P[0]; A.show(2); A.showLabel("D");  // Assign variable point A to P[0], show it as a disk of radius 4, write its label "A" next to it
    pt B=P[1]; B.show(2); B.showLabel("E"); 
    A.to(B);                                // draw a line from A to B in current color (see TAB geo2D, end of class pt)
    stroke(green);
    pt C=P[2]; C.show(2); C.showLabel("A");
    pt D=P[3]; D.show(2); D.showLabel("B");
    pt E=P[4]; E.show(2); E.showLabel("C");
    C.to(D);
    C.to(E);
    D.to(E);
    stroke(orange);
    showEdgeEdgeIntersection(A,B,C,D,E);      // WHERE THE ACTUAL INTERSECTION IS COMPUTED AND DISPLAYED (see below)

    fill(black);     
    };

public void showEdgeEdgeIntersection(pt A, pt B, pt C, pt D, pt E) { // show intersection point between two edges if it exists
  int intersections = 0;
  pt[] intesection = new pt[2];
  pt oneSide = P(0,0);
  boolean overlapping = false;
  if (edgesCross(A, B, C, D)) {        // test if edge(A,B) and edge(C,D) actually intersect (see below)                 // TESTS THE FIRST SEGMENT CD
    vec T=V(A,B);                      // make vector T=AB
    vec N = R(V(C,D));                 // makes vector N by rotating CD by 90 degrees 
    vec AC = V(A,C);
    float t = dot(AC,N) / dot(T,N);    // compute intersection parameter
    vec test1 = V(A,B);
    test1.normalize();
    vec test2 = V(C,D);
    test2.normalize();
    if(abs(dot(test1,test2)) > .9999f){
      overlapping = true;
      pt center = P(0,0);
      pt xAxis = P(1,0);
      pt start = A;
      pt midStart = P(0,0);
      pt midEnd = P(0,0);
      pt finish = A;
      if(dot(V(center,xAxis),V(center,finish)) < dot(V(center,xAxis),V(center,B))){
        finish = B;
      }
      if(dot(V(center,xAxis),V(center,finish)) < dot(V(center,xAxis),V(center,C))){
        finish = C;
      }
      if(dot(V(center,xAxis),V(center,finish)) < dot(V(center,xAxis),V(center,D))){
        finish = D;
      }
      
      if(dot(V(center,xAxis),V(center,start)) > dot(V(center,xAxis),V(center,B))){
        start = B;
      }
      if(dot(V(center,xAxis),V(center,start)) > dot(V(center,xAxis),V(center,C))){
        start = C;
      }
      if(dot(V(center,xAxis),V(center,start)) > dot(V(center,xAxis),V(center,D))){
        start = D;
      }
      if(A != start && A != finish){
        midStart = A;
        if(B != start && B != finish){
          midEnd = B;
        }else if(C != start && C != finish){
          midEnd = C;
        }else{
          midEnd = D;
        }
      }else if(B != start && B!=finish){
        midStart = B;
        if(C != start && C != finish){
          midEnd = C;
        }else{
          midEnd = D;
        }
      }else{
        midStart = C;
        midEnd = D;
      }  
      midStart.to(midEnd);
      show(S(midStart,0,T));
      show(S(midEnd,0,T));
      
    }else{
      show(S(A,t,T));                    // show() shows a point as a small disk. S() computes a point on a line (see TAB geo2D)
      oneSide = S(A,t,T);
      intesection[intersections] = S(A,t,T);
      intersections ++;
    }
                                                           // EXAMPLES OF DEBUGGING TECHNIQUES
               if (debugging) println("t="+t);             // prints current value of t in the text output pane only once each time user presses '?'
            //   scribe("t of AB="+t,1);                           // prints the value of t at the top of the graphics window (line 1) at each frame
               //stroke(cyan,200); arrow(M(C,D),50,U(N));    // shows semi-transparent 50 pixel arrow from (C+D)/2 aligned with N 
               stroke(orange);
    }
    if(edgesCross(A,B,D,E)){                                                                                                  //TEST THE SECOND SEGMENT DE
      vec T = V(A,B);
      vec N = R(V(D,E));
      vec AD = V(A,D);
      float t = dot(AD,N) / dot(T,N);
      
      
      
      
      
    vec test1 = V(A,B);
    test1.normalize();
    vec test2 = V(D,E);
    test2.normalize();
    if(abs(dot(test1,test2)) > .9999f){
      overlapping = true;
      pt center = P(0,0);
      pt xAxis = P(1,0);
      pt start = A;
      pt midStart = P(0,0);
      pt midEnd = P(0,0);
      pt finish = A;
      if(dot(V(center,xAxis),V(center,finish)) < dot(V(center,xAxis),V(center,B))){
        finish = B;
      }
      if(dot(V(center,xAxis),V(center,finish)) < dot(V(center,xAxis),V(center,D))){
        finish = D;
      }
      if(dot(V(center,xAxis),V(center,finish)) < dot(V(center,xAxis),V(center,E))){
        finish = E;
      }
      
      if(dot(V(center,xAxis),V(center,start)) > dot(V(center,xAxis),V(center,B))){
        start = B;
      }
      if(dot(V(center,xAxis),V(center,start)) > dot(V(center,xAxis),V(center,D))){
        start = D;
      }
      if(dot(V(center,xAxis),V(center,start)) > dot(V(center,xAxis),V(center,E))){
        start = E;
      }
      if(A != start && A != finish){
        midStart = A;
        if(B != start && B != finish){
          midEnd = B;
        }else if(D != start && D != finish){
          midEnd = D;
        }else{
          midEnd = E;
        }
      }else if(B != start && B!=finish){
        midStart = B;
        if(D != start && D != finish){
          midEnd = D;
        }else{
          midEnd = E;
        }
      }else{
        midStart = D;
        midEnd = E;
      }  
      midStart.to(midEnd);
      show(S(midStart,0,T));
      show(S(midEnd,0,T));
      
    }else{
      show(S(A,t,T));                    // show() shows a point as a small disk. S() computes a point on a line (see TAB geo2D)
      intesection[intersections] = S(A,t,T);
      oneSide = S(A,t,T);
      intersections ++;
    }
               if (debugging) println("t="+t);             // prints current value of t in the text output pane only once each time user presses '?'
            //   scribe("t of BC="+t,2);                           // prints the value of t at the top of the graphics window (line 1) at each frame
               //stroke(cyan,200); arrow(M(D,E),50,U(N));    // shows semi-transparent 50 pixel arrow from (C+D)/2 aligned with N 
               stroke(orange);
  } if(edgesCross(A,B,E,C)){                                                                                                //TEST THE THIRD SEGEMNT EC
      vec T = V(A,B);
      vec N = R(V(E,C));
      vec AE = V(A,E);
      float t = dot(AE,N) / dot(T,N);
      
      
      
      
    vec test1 = V(A,B);
    test1.normalize();
    vec test2 = V(E,C);
    test2.normalize();
    if(abs(dot(test1,test2)) > .9999f){
      overlapping = true;
      pt center = P(0,0);
      pt xAxis = P(1,0);
      pt start = A;
      pt midStart = P(0,0);
      pt midEnd = P(0,0);
      pt finish = A;
      if(dot(V(center,xAxis),V(center,finish)) < dot(V(center,xAxis),V(center,B))){
        finish = B;
      }
      if(dot(V(center,xAxis),V(center,finish)) < dot(V(center,xAxis),V(center,E))){
        finish = E;
      }
      if(dot(V(center,xAxis),V(center,finish)) < dot(V(center,xAxis),V(center,C))){
        finish = C;
      }
      
      if(dot(V(center,xAxis),V(center,start)) > dot(V(center,xAxis),V(center,B))){
        start = B;
      }
      if(dot(V(center,xAxis),V(center,start)) > dot(V(center,xAxis),V(center,E))){
        start = E;
      }
      if(dot(V(center,xAxis),V(center,start)) > dot(V(center,xAxis),V(center,C))){
        start = C;
      }
      if(A != start && A != finish){
        midStart = A;
        if(B != start && B != finish){
          midEnd = B;
        }else if(E != start && E != finish){
          midEnd = E;
        }else{
          midEnd = C;
        }
      }else if(B != start && B!=finish){
        midStart = B;
        if(E != start && E != finish){
          midEnd = E;
        }else{
          midEnd = C;
        }
      }else{
        midStart = E;
        midEnd = C;
      }  
      midStart.to(midEnd);
      show(S(midStart,0,T));
      show(S(midEnd,0,T));
      
    }else{
      show(S(A,t,T));                    // show() shows a point as a small disk. S() computes a point on a line (see TAB geo2D)
      intesection[intersections] = S(A,t,T);
      oneSide = S(A,t,T);
      intersections ++;
    }
               if (debugging) println("t="+t);             // prints current value of t in the text output pane only once each time user presses '?'
          //     scribe("t of CA="+t,3);                           // prints the value of t at the top of the graphics window (line 1) at each frame
            //   stroke(cyan,200); arrow(M(E,C),50,U(N));    // shows semi-transparent 50 pixel arrow from (C+D)/2 aligned with N 
               stroke(orange);
    }
      stroke(red);
      if(!overlapping){
        if (intersections == 2){
          intesection[0].to(intesection[1]);
          stroke(orange);
          show(S(intesection[0],0,V(0,1)));
          show(S(intesection[1],0,V(0,1)));
        }else if(intersections == 1){
          pt TB = P(D.x-C.x,D.y-C.y);
          pt TC = P(E.x-C.x,E.y-C.y);
          pt EA = P(A.x-C.x,A.y-C.y);
          float T = (EA.y*TB.x-TB.y*EA.x)/(-1*TC.x*TB.y+TC.y*TB.x);      
          float S = (EA.x-(T*TC.x))/TB.x;
          //scribe("S="+S,4); 
          //scribe("T="+T,5); 
            if(S + T <1 &&S >0 && T >0){
              oneSide.to(A);
              show(S(A,0,V(0,1)));
            }else{
              oneSide.to(B);
              show(S(B,0,V(0,1)));
            }
            stroke(orange);
            show(S(oneSide,0,V(0,1)));
        
        }else{
          pt TB = P(D.x-C.x,D.y-C.y);
          pt TC = P(E.x-C.x,E.y-C.y);
          pt EA = P(A.x-C.x,A.y-C.y);
          float T = (EA.y*TB.x-TB.y*EA.x)/(-1*TC.x*TB.y+TC.y*TB.x);           
          float S = (EA.x-(T*TC.x))/TB.x;
         // scribe("S="+S,4); 
         // scribe("T="+T,5); 
          if(S + T <1 &&S >0 && T >0){
            A.to(B);
            show(S(A,0,V(0,1)));
            show(S(B,0,V(0,1)));
          }
        }
      }
          intersections = 0;
    
  }
  
public boolean ordered(pt A, pt B, pt C) {return (0<dot(V(A,B),V(A,C))) && (dot(V(A,B),V(A,C))<dot(V(A,C),V(A,C))); }  // tests whether B falls between A and C
public boolean edgesCross(pt A, pt B, pt C, pt D) {return (dot(U(R(V(A,B))),V(A,C))>0 != dot(U(R(V(A,B))),V(A,D))>0) // tests whether two edges cross
                                                && (dot(U(R(V(C,D))),V(C,A))>0 != dot(U(R(V(C,D))),V(C,B))>0) ; }
public void scribe(String S) {fill(black); text(S,20,20); noFill();}
public void scribe(String S, int i) {fill(black); text(S,20,20+i*20); noFill();}

public void mousePressed() { if (mouse().isInWindow()) pickClosestPoint(); else ; } // select closest vertex (see TAB polygon)
  
public void keyPressed() {  
  if (key==' ') showHelpText=!showHelpText ; 
  if (key=='X') {String S=" "+"-####.tif"; saveFrame(S);};   ;
  if (key=='?') debugging=true;  // toggle debug mode
  };     

public void showHelp() {
    fill(dblue); pushMatrix(); translate(20,20);
     text("Edge/Triangle intersection by Alex Scarlata",0,0); translate(0,20);

     text("  ",0,0); translate(0,20);
     text("First click in the window to activate it ",0,0); translate(0,20);
     text("Press SPACE to show/hide this help text",0,0); translate(0,20);
     text("Click & drag vertices ",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("When running Processing (not in a web browser): ",0,0); translate(0,20);
     text("Press 'X' to snap a picture ()",0,0); translate(0,20);
     text("Press '?' to print your debugging stuff",0,0); translate(0,20);
     popMatrix(); noFill();
     showColors();                                                     // showing off various colors (helps you select the one you want)
    }
     
int red, yellow, green, cyan, blue, magenta, dred, dyellow, dgreen, dcyan, dblue, dmagenta, white, black, orange, grey, metal;  // declares color names
public void setColors() {
  colorMode(HSB,121);
  red = color(0, 120, 120); yellow = color(20, 120, 120); green = color(40, 120, 120); cyan = color(60, 120, 120); blue = color(80, 120, 120); magenta = color(100, 120, 120); 
  dred = color(0, 120, 60); dyellow = color(20, 120, 60); dgreen = color(40, 120, 60); dcyan = color(60, 120, 60); dblue = color(80, 120, 60); dmagenta = color(100, 120, 60); 
  white = color(0, 0, 120); black = color(0, 120,0); grey = color(0, 0,60); orange = color(10, 100, 120); metal = color(70, 60, 100); };
public int ramp(int c, int m) {float f=255.f*c/m; return color(f,255.f-f,255.f-f/2);}  // returns color c in rammp from 0 to n
public void showColors() {
   noStroke(); // do not draw any lines nor the borders of filled figures
   pt q=new pt(0,0); translate(30,height-50); 
   pushMatrix();
   fill(red); q.show(10); translate(20,0);
   fill(yellow); q.show(10); translate(20,0);
   fill(green); q.show(10); translate(20,0);
   fill(cyan); q.show(10); translate(20,0);
   fill(blue); q.show(10); translate(20,0);
   fill(magenta); q.show(10); translate(20,0);
   fill(grey); q.show(10); translate(20,0);
   popMatrix();
   translate(0,20);
   pushMatrix();
   fill(dred); q.show(10); translate(20,0);
   fill(dyellow); q.show(10); translate(20,0);
   fill(dgreen); q.show(10); translate(20,0);
   fill(dcyan); q.show(10); translate(20,0);
   fill(dblue); q.show(10); translate(20,0);
   fill(dmagenta); q.show(10); translate(20,0);
   fill(black); q.show(10); translate(20,0);
   popMatrix();
   }
//*************************************************************
//**** 2D GEOMETRY CLASSES AND UTILITIES, Jarek Rossignac *****
//****          SIMPLIFIED August 31 2008                 *****
//**** DISCLAIMER: These utilities may contain errors     *****
//*************************************************************
public pt P(pt P) {return new pt(P.x,P.y); };                                              // make copy of point
public pt P(float x, float y) {return new pt(x,y); };                                      // make point (x,y)
public pt A(pt A, pt B) {return new pt(A.x+B.x,A.y+B.y); };                                // A+B
public pt A(pt A, float s, pt B) {return new pt(A.x+s*B.x,A.y+s*B.y); };                   // A+sB
public pt S(float s, pt A) {return new pt(s*A.x,s*A.y); };                                 // sA
public pt S(pt A, float s, pt B) {return new pt(A.x+s*(B.x-A.x),A.y+s*(B.y-A.y)); };       // A+sAB
public pt S(pt P, float s, vec V) {return new pt(P.x + s*V.x, P.y + s*V.y); }              // P+sV
public pt S(pt P, vec V) {return new pt(P.x + V.x, P.y + V.y); }                           // P+V
public pt M(pt A, pt B) {return(new pt((A.x+B.x)/2.0f,(A.y+B.y)/2.0f)); };                   // (A+B)/2
public pt M(pt A, pt B, pt C) {return new pt((A.x+B.x+C.x)/3.0f,(A.y+B.y+C.y)/3.0f); };      // (A+B+C)/3
public pt M(float a, pt A, float b, pt B) {return A(S(a,A),b,B);}                          // aA+bB 
public pt M(float a, pt A, float b, pt B, float c, pt C) {return A(S(a,A),M(b,B,c,C));}    // aA+bB+cC 
public pt M(float a, pt A, float b, pt B, float c, pt C, float d, pt D){return A(M(a,A,b,B),M(c,C,d,D));}   // aA+bB+cC+dD
public pt T(pt P, float s, vec V) {float n = n(V); if (n>0) return new pt(P.x + s/n*V.x, P.y + s/n*V.y);  else return P(P);} // P+sV/||V||
public pt T(pt P, float s, pt Q) {vec V = V(P,Q); return T(P,s,V) ; };                      // P+sPQ/||PQ||
public pt R(pt Q, float a, pt P) {float dx=Q.x-P.x, dy=Q.y-P.y, c=cos(a), s=sin(a); return P(P.x+c*dx+s*dy, P.y-s*dx+c*dy); }; // Rotated Q by a around P
public pt R(pt Q, float a) {float dx=Q.x, dy=Q.y, c=cos(a), s=sin(a); return new pt(c*dx+s*dy, -s*dx+c*dy); };                 // Rotated Q by a around origin
public vec V(vec V) {return new vec(V.x,V.y); };                                            // make copy of vector V
public vec V(float x, float y) {return new vec(x,y); };                                     // make vector (x,y)
public vec V(pt P, pt Q) {return new vec(Q.x-P.x,Q.y-P.y);};                                // PQ
public vec R(vec V) {return new vec(-V.y,V.x);};                                            // V turned right 90 degrees (as seen on screen)
public vec U(vec V) {float n = n(V); if (n==0) return new vec(0,0); else return new vec(V.x/n,V.y/n);}; // V/||V||
public vec S(float s,vec V) {return new vec(s*V.x,s*V.y);};                                  // sV
public vec S(vec U,float s,vec V) {return new vec(U.x+s*(V.x-U.x),U.y+s*(V.y-U.y));};            // (1-s)U+sV
public vec M(vec U, vec V) {return new vec((U.x+V.x)/2.0f,(U.y+V.y)/2.0f); };                 // (U+V)/2
public vec M(float a, vec U, float b, vec V) {return new vec(a*U.x+b*V.x,a*U.y+b*V.y);}      // aU+bV 
public vec R(vec U, float a) {vec W = U.makeRotatedBy(a);  return W ; };                     // U rotated by a
public vec R(vec U, float s, vec V) {float a = angle(U,V); vec W = U.makeRotatedBy(s*a);     // interpolation (angle and length) between U and V
    float u = n(U); float v=n(V); S((u+s*(v-u))/u,W); return W ; };
public float d(pt P, pt Q) {return sqrt(sq(Q.x-P.x)+sq(Q.y-P.y)); };                        // ||AB||
public float n(vec V) {return sqrt(sq(V.x)+sq(V.y));};                                       // ||V||
public float n2(vec V) {return sq(V.x)+sq(V.y);};                                            // V*V
public float dot(vec U, vec V) {return U.x*V.x+U.y*V.y; };                                   //U*V
public float a (vec U, vec V) {float a = atan2(dot(R(U),V),dot(U,V));                          // angle(U<V) between -PI and PI
     if(a>PI) return mPItoPIangle(a-2*PI); if(a<-PI) return mPItoPIangle(a+2*PI); return a; };

public pt Mouse() {return(new pt(mouseX,mouseY));};                                         // current mouse location
public vec MouseDrag() {return new vec(mouseX-pmouseX,mouseY-pmouseY);};                     // vector representing recent mouse displacement
public void v(pt P) {vertex(P.x,P.y);};                                                     // next point when drawing polygons between beginShape(); and endShape();
public void cross(pt P, float r) {line(P.x-r,P.y,P.x+r,P.y); line(P.x,P.y-r,P.x,P.y+r);};   // shows P as cross of length r
public void cross(pt P) {cross(P,2);};                                                      // shows P as small cross
public void show(pt P, float r) {ellipse(P.x, P.y, 2*r, 2*r);};                             // draws circle of center r around point
public void show(pt P) {ellipse(P.x, P.y, 4,4);};                                           // draws small circle around point
public void show(pt P, pt Q) {line(P.x,P.y,Q.x,Q.y); };                                     // draws edge (P,Q)
public void show(pt P, vec V) {line(P.x,P.y,P.x+V.x,P.y+V.y); }                             // show line from P along V
public void show(pt P, float s, vec V) {show(P,S(s,V));}                                    // show line from P along sV
public void arrow(pt P, pt Q) {arrow(P,V(P,Q)); }                                           // draws arrow from P to Q
public void arrow(pt P, float s, vec V) {arrow(P,S(s,V));}                                   // show arrow from P along sV
public void arrow(pt P, vec V) {show(P,V);  float n=n(V); float s=max(min(0.2f,20.f/n),6.f/n);  // show arrow from P along V
  pt Q=S(P,V); vec U = S(-s,V); vec W = R(S(.3f,U)); beginShape(); v(S(S(Q,U),W)); v(Q); v(S(S(Q,U),-1,W)); endShape(CLOSE);}; 

public boolean right(pt A, pt B, pt C) {return dot( A.makeVecTo(B).makeTurnedLeft() , B.makeVecTo(C) ) >0 ; };  // right turn (as seen on screen)
public boolean isRightTurn(pt A, pt B, pt C) {return dot( R(V(A,B)),V(B,C)) > 0 ; };  // right turn (as seen on screen)
public boolean isRightOf(pt A, pt Q, vec T) {return dot(R(T),V(Q,A)) > 0 ; };                   // A is on right of ray(Q,T) (as seen on screen)
public float a(pt A, pt B, pt C) {return  a(V(B,A),V(B,C)); }                               // angle (A,B,C)
public float area(pt A, pt B, pt C) {return 0.5f*dot(V(A,C),R(V(A,B))); }                    // signed area of triangle
public float rBubble (pt A, pt B, pt C) {                                                  // grows as bubble pushes through, r>0 when ABC ic clockwise
    float a=d(B,C), b=d(C,A), c=d(A,B);
    float s=(a+b+c)/2; float d=sqrt(s*(s-a)*(s-b)*(s-c)); float r=a*b*c/4/d;
    if (abs(a(A,B,C))>PI/2) r=sq(d(A,C)/2)/r;
    if (abs(a(C,A,B))>PI/2) r=sq(d(C,B)/2)/r;
    if (abs(a(B,C,A))>PI/2) r=sq(d(B,A)/2)/r;
    if (!right(A,B,C)) r=-r;
    return r;
   };
public pt center (pt A, pt B, pt C) { vec AB = V(A,B); vec AC = R(V(A,C)); return S(A,1.f/2/dot(AB,AC),M(-n2(AC),R(AB),n2(AB),AC)); }; // circumcenter
  
//************************************************************************
//**** POINTS
//************************************************************************
class pt { float x=0,y=0; 
  // CREATE
  pt () {}
  pt (float px, float py) {x = px; y = py;};
  pt (pt P) {x = P.x; y = P.y;};
  pt (pt P, vec V) {x = P.x+V.x; y = P.y+V.y;};
  pt (pt P, float s, vec V) {x = P.x+s*V.x; y = P.y+s*V.y;};
  pt (pt A, float s, pt B) {x = A.x+s*(B.x-A.x); y = A.y+s*(B.y-A.y);};

  // MODIFY
  public void setTo(float px, float py) {x = px; y = py;};  
  public void setTo(pt P) {x = P.x; y = P.y;}; 
  public void setToMouse() { x = mouseX; y = mouseY; }; 
  public void moveWithMouse() { x += mouseX-pmouseX; y += mouseY-pmouseY; }; 
  public void translateToTrack(float s, pt P) {setTo(T(P,s,V(P,this)));};
  public void track(float s, pt P) {setTo(T(P,s,V(P,this)));};
  public void scaleBy(float f) {x*=f; y*=f;};
  public void scaleBy(float u, float v) {x*=u; y*=v;};
  public void translateBy(vec V) {x += V.x; y += V.y;};   
  public void translateBy(float s, vec V) {x += s*V.x; y += s*V.y;};   
  public void translateBy(float u, float v) {x += u; y += v;};
  public void translateTowards(float s, pt P) {x+=s*(P.x-x);  y+=s*(P.y-y); };
  public void translateTowardsBy(float s, pt P) {vec V = this.makeVecTo(P); V.normalize(); this.translateBy(s,V); };
  public void addPt(pt P) {x += P.x; y += P.y;};        // incorrect notation, but useful for computing weighted averages
  public void addScaledPt(float s, pt P) {x += s*P.x; y += s*P.y;};        // incorrect notation, but useful for computing weighted averages
  public void rotateBy(float a) {float dx=x, dy=y, c=cos(a), s=sin(a); x=c*dx+s*dy; y=-s*dx+c*dy; };     // around origin
  public void rotateBy(float a, pt P) {float dx=x-P.x, dy=y-P.y, c=cos(a), s=sin(a); x=P.x+c*dx+s*dy; y=P.y-s*dx+c*dy; };   // around point P
  public void rotateBy(float s, float t, pt P) {float dx=x-P.x, dy=y-P.y; dx-=dy*t; dy+=dx*s; dx-=dy*t; x=P.x+dx; y=P.y+dy; };   // s=sin(a); t=tan(a/2);
  public void clipToWindow() {x=max(x,0); y=max(y,0); x=min(x,height); y=min(y,height); }
  
  // OUTPUT POINT
  public pt clone() {return new pt(x,y); };
  public pt makeClone() {return new pt(x,y); };
  public pt makeTranslatedBy(vec V) {return(new pt(x + V.x, y + V.y));};
  public pt makeTranslatedBy(float s, vec V) {return(new pt(x + s*V.x, y + s*V.y));};
  public pt makeTransaltedTowards(float s, pt P) {return(new pt(x + s*(P.x-x), y + s*(P.y-y)));};
  public pt makeTranslatedBy(float u, float v) {return(new pt(x + u, y + v));};
  public pt makeRotatedBy(float a, pt P) {float dx=x-P.x, dy=y-P.y, c=cos(a), s=sin(a); return(new pt(P.x+c*dx+s*dy, P.y-s*dx+c*dy)); };
  public pt makeRotatedBy(float a) {float dx=x, dy=y, c=cos(a), s=sin(a); return(new pt(c*dx+s*dy, -s*dx+c*dy)); };
  public pt makeProjectionOnLine(pt P, pt Q) {float a=dot(P.makeVecTo(this),P.makeVecTo(Q)), b=dot(P.makeVecTo(Q),P.makeVecTo(Q)); return(P.makeTransaltedTowards(a/b,Q)); };
  public pt makeOffset(pt P, pt Q, float r) {
    float a = angle(vecTo(P),vecTo(Q))/2;
    float h = r/tan(a); 
    vec T = vecTo(P); T.normalize(); vec N = T.left();
    pt R = new pt(x,y); R.translateBy(h,T); R.translateBy(r,N);
    return R; };

   // OUTPUT VEC
  public vec vecTo(pt P) {return(new vec(P.x-x,P.y-y)); };
  public vec makeVecTo(pt P) {return(new vec(P.x-x,P.y-y)); };
  public vec makeVecToCenter () {return(new vec(x-height/2.f,y-height/2.f)); };
  public vec makeVecToAverage (pt P, pt Q) {return(new vec((P.x+Q.x)/2.0f-x,(P.y+Q.y)/2.0f-y)); };
  public vec makeVecToAverage (pt P, pt Q, pt R) {return(new vec((P.x+Q.x+R.x)/3.0f-x,(P.y+Q.y+R.x)/3.0f-y)); };
  public vec makeVecToMouse () {return(new vec(mouseX-x,mouseY-y)); };
  public vec makeVecToBisectProjection (pt P, pt Q) {float a=this.disTo(P), b=this.disTo(Q);  return(this.makeVecTo(interpolate(P,a/(a+b),Q))); };
  public vec makeVecToNormalProjection (pt P, pt Q) {float a=dot(P.makeVecTo(this),P.makeVecTo(Q)), b=dot(P.makeVecTo(Q),P.makeVecTo(Q)); return(this.makeVecTo(interpolate(P,a/b,Q))); };
  public vec makeVecTowards(pt P, float d) {vec V = makeVecTo(P); float n = V.norm(); V.normalize(); V.scaleBy(d-n); return V; };
 
  // OUTPUT TEST OR MEASURE
  public float disTo(pt P) {return(sqrt(sq(P.x-x)+sq(P.y-y))); };
  public float disToMouse() {return(sqrt(sq(x-mouseX)+sq(y-mouseY))); };
  public boolean isInWindow() {return(((x>0)&&(x<height)&&(y>0)&&(y<height)));};
  public boolean projectsBetween(pt P, pt Q) {float a=dot(P.makeVecTo(this),P.makeVecTo(Q)), b=dot(P.makeVecTo(Q),P.makeVecTo(Q)); return((0<a)&&(a<b)); };
  public float ratioOfProjectionBetween(pt P, pt Q) {float a=dot(P.makeVecTo(this),P.makeVecTo(Q)), b=dot(P.makeVecTo(Q),P.makeVecTo(Q)); return(a/b); };
  public float disToLine(pt P, pt Q) {float a=dot(P.makeVecTo(this),P.makeVecTo(Q).makeUnit().makeTurnedLeft()); return(abs(a)); };
  public boolean isLeftOf(pt P, pt Q) {boolean l=dot(P.makeVecTo(this),P.makeVecTo(Q).makeTurnedLeft())>0; return(l);  };
  public boolean isInTriangle(pt A, pt B, pt C) { boolean a = this.isLeftOf(B,C); boolean b = this.isLeftOf(C,A); boolean c = this.isLeftOf(A,B); return((a&&b&&c)||(!a&&!b&&!c));};
  public boolean isInCircle(pt C, float r) {return d(this,C)<r; }  // returns true if point is in circle C,r
  
  // DRAW, PRINT
  public void show() {ellipse(x, y, height/200, height/200); }; // shows point as small dot
  public void show(float r) {ellipse(x, y, 2*r, 2*r); }; // shows point as disk of radius r
  public void showCross(float r) {line(x-r,y,x+r,y); line(x,y-r,x,y+r);}; 
  public void v() {vertex(x,y);};  // used for drawing polygons between beginShape(); and endShape();
  public void write() {println("("+x+","+y+")");};  // writes point coordinates in text window
  public void showLabel(String s, vec D) {text(s, x+D.x,y+D.y);  };  // show string displaced by vector D from point
  public void showLabel(String s) {text(s, x+5,y+4);  };
  public void showLabel(int i) {text(str(i), x+5,y+4);  };  // shows integer number next to point
  public void showLabel(String s, float u, float v) {text(s, x+u, y+v);  };
  public void showSegmentTo (pt P) {line(x,y,P.x,P.y); }; // draws edge to another point
  public void to (pt P) {line(x,y,P.x,P.y); }; // draws edge to another point

  } // end of pt class

public pt mouse() {return(new pt(mouseX,mouseY));};  // current mouse location
public pt mid(pt A, pt B) {return(new pt((A.x+B.x)/2.0f,(A.y+B.y)/2.0f)); };
public pt average(pt A, pt B) {return(new pt((A.x+B.x)/2.0f,(A.y+B.y)/2.0f)); };
public pt average(pt A, pt B, pt C) {return(new pt((A.x+B.x+C.x)/3.0f,(A.y+B.y+C.y)/3.0f)); };
public pt mouseInWindow() {float x=mouseX, y=mouseY; x=max(x,0); y=max(y,0); x=min(x,height); y=min(y,height);  return(new pt(x,y));}; // clips mouse to square window
public pt screenCenter() {return(new pt(height/2,height/2));}  // point in center of screen
public pt interpolate(pt A, float s, pt B) {return(new pt(A.x+s*(B.x-A.x),A.y+s*(B.y-A.y))); };
public pt weightedSum(float a, pt A, float b, pt B) {pt P =  A.makeClone(); P.scaleBy(a); P.addScaledPt(b,B); return(P);}
public pt weightedSum(float a, pt A, float b, pt B, float c, pt C) {pt P =  A.makeClone(); P.scaleBy(a); P.addScaledPt(b,B);  P.addScaledPt(c,C); return(P);}
public pt scaledAverage(pt A, pt B, pt C, float s) {return(new pt((A.x+B.x+C.x)/s,(A.y+B.y+C.y)/s)); };
public pt weightedSum(float a, pt A, float b, pt B, float c, pt C, float d, pt D) 
        {pt P =  A.makeClone(); P.scaleBy(a); P.addScaledPt(b,B); P.addScaledPt(c,C); P.addScaledPt(d,D); return(P);}
public boolean isLeftTurn(pt A, pt B, pt C) {return(dot(A.makeVecTo(B).makeTurnedLeft() , B.makeVecTo(C) )>0); };  // true if B is a left turn (appears right on the screen, Y goes down)
public boolean mouseIsInWindow() {return(((mouseX>0)&&(mouseX<height)&&(mouseY>0)&&(mouseY<height)));};

//************************************************************************
//**** VECTORS
//************************************************************************
class vec { float x=0,y=0; 
 // CREATE
  vec () {};
  vec (vec V) {x = V.x; y = V.y;};
  vec (float s, vec V) {x = s*V.x; y = s*V.y;};
  vec (float px, float py) {x = px; y = py;};
  vec (pt P, pt Q) {x = Q.x-P.x; y = Q.y-P.y;};
 
 // MODIFY
  public void setTo(float px, float py) {x = px; y = py;}; 
  public void setTo(pt P, pt Q) {x = Q.x-P.x; y = Q.y-P.y;}; 
  public void setTo(vec V) {x = V.x; y = V.y;}; 
  public void scaleBy(float f) {x*=f; y*=f;};
  public void back() {x=-x; y=-y;};
  public void mul(float f) {x*=f; y*=f;};
  public void div(float f) {x/=f; y/=f;};
  public void scaleBy(float u, float v) {x*=u; y*=v;};
  public void normalize() {float n=sqrt(sq(x)+sq(y)); if (n>0.000001f) {x/=n; y/=n;};};
  public void add(vec V) {x += V.x; y += V.y;};   
  public void add(float s, vec V) {x += s*V.x; y += s*V.y;};   
  public void add(float u, float v) {x += u; y += v;};
  public void turnLeft() {float w=x; x=-y; y=w;};
  public void rotateBy (float a) {float xx=x, yy=y; x=xx*cos(a)-yy*sin(a); y=xx*sin(a)+yy*cos(a); };
  
  // OUTPUT VEC
  public vec makeClone() {return(new vec(x,y));}; 
  public vec makeUnit() {float n=sqrt(sq(x)+sq(y)); if (n<0.000001f) n=1; return(new vec(x/n,y/n));}; 
  public vec unit() {float n=sqrt(sq(x)+sq(y)); if (n<0.000001f) n=1; return(new vec(x/n,y/n));}; 
  public vec makeScaledBy(float s) {return(new vec(x*s, y*s));};
  public vec makeTurnedLeft() {return(new vec(-y,x));};
  public vec left() {return(new vec(-y,x));};
  public vec makeOffsetVec(vec V) {return(new vec(x + V.x, y + V.y));};
  public vec makeOffsetVec(float s, vec V) {return(new vec(x + s*V.x, y + s*V.y));};
  public vec makeOffsetVec(float u, float v) {return(new vec(x + u, y + v));};
  public vec makeRotatedBy(float a) {return(new vec(x*cos(a)-y*sin(a),x*sin(a)+y*cos(a))); };
  public vec makeReflectedVec(vec N) { return makeOffsetVec(-2.f*dot(this,N),N);};

  // OUTPUT TEST MEASURE
  public float norm() {return(sqrt(sq(x)+sq(y)));}
  public boolean isNull() {return((abs(x)+abs(y)<0.000001f));}
  public float angle() {return(atan2(y,x)); }

  // DRAW, PRINT
  public void write() {println("("+x+","+y+")");};
  public void show (pt P) {line(P.x,P.y,P.x+x,P.y+y); }; 
  public void showAt (pt P) {line(P.x,P.y,P.x+x,P.y+y); }; 
  public void showArrowAt (pt P) {line(P.x,P.y,P.x+x,P.y+y); 
      float n=min(this.norm()/10.f,height/50.f); 
      pt Q=P.makeTranslatedBy(this); 
      vec U = this.makeUnit().makeScaledBy(-n);
      vec W = U.makeTurnedLeft().makeScaledBy(0.3f);
      beginShape(); Q.makeTranslatedBy(U).makeTranslatedBy(W).v(); Q.v(); 
                    W.scaleBy(-1); Q.makeTranslatedBy(U).makeTranslatedBy(W).v(); endShape(CLOSE); }; 
  public void showLabel(String s, pt P) {pt Q = P.makeTranslatedBy(0.5f,this); 
           vec N = makeUnit().makeTurnedLeft(); Q.makeTranslatedBy(3,N).showLabel(s); };
  } // end vec class
 
public vec average(vec U, vec V) {return(new vec((U.x+V.x)/2.0f,(U.y+V.y)/2.0f)); };
public vec mouseDrag() {return new vec(mouseX-pmouseX,mouseY-pmouseY);};

//************************************************************************
//**** ANGLES
//************************************************************************
public float angle(vec V) {return(atan2(V.y,V.x)); };
public float angle(vec U, vec V) {return(atan2(dot(U.makeTurnedLeft(),V),dot(U,V))); };
public float mPItoPIangle(float a) { if(a>PI) return(mPItoPIangle(a-2*PI)); if(a<-PI) return(mPItoPIangle(a+2*PI)); return(a);};
public float toDeg(float a) {return(a*180/PI);}
public float toRad(float a) {return(a*PI/180);}

//************************************************************************
//**** TRIANGLES
//************************************************************************
public boolean ccw(pt A, pt B, pt C) {return C.isLeftOf(A,B) ;}
public float triArea(pt A, pt B, pt C) {return 0.5f*dot(A.makeVecTo(B),A.makeVecTo(C).makeTurnedLeft()); }
public float triThickness(pt A, pt B, pt C) {float a = abs(dot(V(B,A),U(R(V(B,C))))), b = abs(dot(V(C,B),U(R(V(C,A))))), c = abs(dot(V(A,C),U(R(V(A,B))))); return min (a,b,c); } 
public void show(pt A, pt B, pt C)  {beginShape();  A.v(); B.v(); C.v(); endShape(CLOSE);}
public void show(pt A, pt B, pt C, float r) {if (triThickness(A,B,C)<2*r) return;
    float s=r; if (!ccw(A,B,C)) s=-s; pt AA = A.makeOffset(B,C,s); pt BB = B.makeOffset(C,A,s); pt CC = C.makeOffset(A,B,s); 
    beginShape();  AA.v(); BB.v(); CC.v(); endShape(CLOSE);
    }
public float triInRadius (pt A, pt B, pt C)  {  float Z=triArea(A,B,C), a=B.disTo(C), b=C.disTo(A), c=A.disTo(B), s=a+b+c;  return 2*Z/s;  }
 public pt triCenter (pt A, pt B, pt C)  {return average(A,B,C);}
 public pt triInCenter (pt A, pt B, pt C)  {  float Z=triArea(A,B,C), a=B.disTo(C), b=C.disTo(A), c=A.disTo(B), s=a+b+c, r=2*Z/s, R=a*b*c/(2*r*s);
     return weightedSum(a/s,A,b/s,B,c/s,C);  }
 public pt triCenterD (pt A, pt B, pt C)  {  float Z=triArea(A,B,C), a=B.disTo(C), b=C.disTo(A), c=A.disTo(B), ss=a*a+b*b+c*c;
     return weightedSum(a*a/ss,A,b*b/ss,B,c*c/ss,C);  }
 public pt triCenterN (pt A, pt B, pt C)  {  float Z=triArea(A,B,C), a=B.disTo(C), b=C.disTo(A), c=A.disTo(B), s=a+b+c;
     return weightedSum((s-a)/2/s,A,(s-b)/2/s,B,(s-c)/2/s,C);  }



//*****************************************************************************
// TITLE:         Edge-Edge Intersection 
// DESCRIPTION:   Example (starting point) for class projects. Assumes general position. 
// AUTHOR:        Prof Jarek Rossignac
// DATE CREATED:  August 2008
// EDITS:
//*****************************************************************************
boolean showHelpText=true;       // toggled by keys to show/hide help text
boolean debugging=false;           // temporarily set when key '?' is pressed (see TAB UI). can be used to print some debugging statements once

public void setup() { 
  size(600, 600);                                                   // set window size
  smooth();                                                         // activates antialiasing (slower but removes jaggies). Incompatible with P3D
  setColors();                                                      // assigns colors in TAB colors
  PFont font = loadFont("ArialMT-24.vlw"); textFont(font, 12);      // load font
  declarePoints(); resetPoints();                                   // initializes vertices in TAB polygon
  } 

public void draw() { 
  background(121);  // sets background
  if (showHelpText) showHelp();                                     // show help text OR
  else myActions();                                                 // execute my actions in TAB actions
  debugging=false;                                                    // reset debugging to avoid printing twice
  };  // end of draw
  
 


  
 
// ************ SIMPLE UTILITIES FOR PROCESSING A POLYGON STORED IN pt P[n]*******
int n=5;                        // current number of points
pt [] P = new pt[1000];            // decalres an array of vertices
int p=0;                         // index to the currently selected vertex being dragged
public int next(int j) {  if (j==n-1) {return (0);}  else {return(j+1);}  };  // next point in loop
public int prev(int j) {  if (j==0) {return (n-1);}  else {return(j-1);}  };  // previous point in loop                                                     
public void declarePoints() {for (int i=0; i<P.length; i++) P[i]=new pt();} // init the vertices to be on a circle
public void resetPoints() {for (int i=0; i<n; i++) {P[i]=new pt(width/2,height/7.f); P[i].rotateBy(2.f*PI*i/n, screenCenter());}; } // init the points to be on a circle
public void appendPoint(pt Q)  { P[n++].setTo(Q);  }; // add point at end of list
// ************************************** EDITING *********************************
public void dragPoint() { P[p].moveWithMouse(); P[p].clipToWindow(); }   // moves selected point (P[p]) by recent mouse displacement (see TAB polygon)
public void dragPoint(vec V) {P[p].translateBy(V);}                      // moves P[p] by vector V
public void pickClosestPoint() {pt M = mouse(); p=0; for (int i=1; i<n; i++) if (M.disTo(P[i])<M.disTo(P[p])) p=i;} // sets p to the index of point closest to mouse
public void pickClosestPoint(pt M) {if(mouseIsInWindow()) { p=0; for (int i=1; i<n; i++) if (M.disTo(P[i])<M.disTo(P[p])) p=i; };}
public void deletePoint() { for (int i=p; i<n-1; i++) P[i].setTo(P[next(i)]); n--; p=prev(p);}
public void translatePoints(vec V) {for (int i=0; i<n; i++) P[i].translateBy(V); };   
public void scalePoints(float s) {for (int i=0; i<n; i++) P[i].translateTowards(s,screenCenter());};  
// ************************************** VIEWING *********************************
public void showPoints() {for (int i=0; i<n; i++) P[i].show();}
public void showPoints(int r) {for (int i=0; i<n; i++) P[i].show(r);}
public void drawPointIDs() {for (int i=0; i<n; i++) {vec V=P[i].makeVecToAverage(P[prev(i)],P[next(i)]); V.normalize(); V.scaleBy(-10); V.add(-3,5); P[i].showLabel(str(i),V); };}; 
public void drawPolygon() {beginShape();  for (int i=0; i<n; i++) P[i].v(); endShape(CLOSE); }    
public void drawPolygon(boolean closed) {beginShape();  for (int i=0; i<n; i++) P[i].v(); if(closed) endShape(CLOSE); else endShape();} // draw (or fill) open (or closed) polygon
public void drawEdge(int i) {if((0<=i)&&(i<n)) P[i].to(P[next(i)]);}


  static public void main(String args[]) {     PApplet.main(new String[] { "actions" });  }}